import { Component, ChangeDetectionStrategy, forwardRef, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TdSeriesDirective, TdChartOptionsService } from '@covalent/echarts/base';

/**
 * @fileoverview added by tsickle
 * Generated from: scatter.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ITdScatterSeries() { }
if (false) {
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.coordinateSystem;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.xAxisIndex;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.yAxisIndex;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.polarIndex;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.geoIndex;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.calendarIndex;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.hoverAnimation;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.legendHoverLink;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.symbol;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.symbolSize;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.symbolRotate;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.symbolKeepAspect;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.symbolOffset;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.large;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.largeThreshold;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.cursor;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.connectNulls;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.clipOverflow;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.step;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.label;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.itemStyle;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.emphasis;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.progressive;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.progressiveThreshold;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.dimensions;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.encode;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.seriesLayoutBy;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.datasetIndex;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.data;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.markPoint;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.markLine;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.markArea;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.zlevel;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.z;
    /** @type {?|undefined} */
    ITdScatterSeries.prototype.silent;
}
class TdChartSeriesScatterComponent extends TdSeriesDirective {
    /**
     * @param {?} _optionsService
     */
    constructor(_optionsService) {
        super('scatter', _optionsService);
    }
    /**
     * @return {?}
     */
    getConfig() {
        return {
            coordinateSystem: this.coordinateSystem,
            xAxisIndex: this.xAxisIndex,
            yAxisIndex: this.yAxisIndex,
            polarIndex: this.polarIndex,
            geoIndex: this.geoIndex,
            calendarIndex: this.calendarIndex,
            hoverAnimation: this.hoverAnimation,
            legendHoverLink: this.legendHoverLink,
            symbol: this.symbol,
            symbolSize: this.symbolSize,
            symbolRotate: this.symbolRotate,
            symbolKeepAspect: this.symbolKeepAspect,
            symbolOffset: this.symbolOffset,
            large: this.large,
            largeThreshold: this.largeThreshold,
            cursor: this.cursor,
            label: this.label,
            itemStyle: this.itemStyle,
            emphasis: this.emphasis,
            progressive: this.progressive,
            progressiveThreshold: this.progressiveThreshold,
            dimensions: this.dimensions,
            encode: this.encode,
            seriesLayoutBy: this.seriesLayoutBy,
            datasetIndex: this.datasetIndex,
            markPoint: this.markPoint,
            markLine: this.markLine,
            markArea: this.markArea,
            zlevel: this.zlevel,
            z: this.z,
            silent: this.silent,
        };
    }
}
TdChartSeriesScatterComponent.decorators = [
    { type: Component, args: [{
                selector: 'td-chart-series[td-scatter]',
                template: '',
                changeDetection: ChangeDetectionStrategy.OnPush,
                inputs: [
                    'config',
                    'id',
                    'name',
                    'color',
                    'data',
                    'animation',
                    'animationThreshold',
                    'animationDuration',
                    'animationEasing',
                    'animationDelay',
                    'animationDurationUpdate',
                    'animationEasingUpdate',
                    'animationDelayUpdate',
                    'tooltip',
                ],
                providers: [
                    {
                        provide: TdSeriesDirective,
                        useExisting: forwardRef((/**
                         * @return {?}
                         */
                        () => TdChartSeriesScatterComponent)),
                    },
                ]
            }] }
];
/** @nocollapse */
TdChartSeriesScatterComponent.ctorParameters = () => [
    { type: TdChartOptionsService }
];
TdChartSeriesScatterComponent.propDecorators = {
    coordinateSystem: [{ type: Input }],
    xAxisIndex: [{ type: Input }],
    yAxisIndex: [{ type: Input }],
    polarIndex: [{ type: Input }],
    geoIndex: [{ type: Input }],
    calendarIndex: [{ type: Input }],
    hoverAnimation: [{ type: Input }],
    legendHoverLink: [{ type: Input }],
    symbol: [{ type: Input }],
    symbolSize: [{ type: Input }],
    symbolRotate: [{ type: Input }],
    symbolKeepAspect: [{ type: Input }],
    symbolOffset: [{ type: Input }],
    large: [{ type: Input }],
    largeThreshold: [{ type: Input }],
    cursor: [{ type: Input }],
    label: [{ type: Input }],
    itemStyle: [{ type: Input }],
    emphasis: [{ type: Input }],
    progressive: [{ type: Input }],
    progressiveThreshold: [{ type: Input }],
    dimensions: [{ type: Input }],
    encode: [{ type: Input }],
    seriesLayoutBy: [{ type: Input }],
    datasetIndex: [{ type: Input }],
    markPoint: [{ type: Input }],
    markLine: [{ type: Input }],
    markArea: [{ type: Input }],
    zlevel: [{ type: Input }],
    z: [{ type: Input }],
    silent: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.coordinateSystem;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.xAxisIndex;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.yAxisIndex;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.polarIndex;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.geoIndex;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.calendarIndex;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.hoverAnimation;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.legendHoverLink;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.symbol;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.symbolSize;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.symbolRotate;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.symbolKeepAspect;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.symbolOffset;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.large;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.largeThreshold;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.cursor;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.label;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.itemStyle;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.emphasis;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.progressive;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.progressiveThreshold;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.dimensions;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.encode;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.seriesLayoutBy;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.datasetIndex;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.markPoint;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.markLine;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.markArea;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.zlevel;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.z;
    /** @type {?} */
    TdChartSeriesScatterComponent.prototype.silent;
}

/**
 * @fileoverview added by tsickle
 * Generated from: scatter.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const SCATTER_MODULE_COMPONENTS = [TdChartSeriesScatterComponent];
class CovalentScatterEchartsModule {
}
CovalentScatterEchartsModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [SCATTER_MODULE_COMPONENTS],
                exports: [SCATTER_MODULE_COMPONENTS],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: covalent-echarts-scatter.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CovalentScatterEchartsModule, SCATTER_MODULE_COMPONENTS, TdChartSeriesScatterComponent };
//# sourceMappingURL=covalent-echarts-scatter.js.map
